#include <stdio.h>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int N, Q;
    long long int a, b, c;
    vector<long long int> p;
    vector<long long int> tren;
    vector<long long int> pojedeno;
    vector<long long int> pocetak;
    vector<long long int> d;
    vector<long long int> k;
    cin >> N >> Q;
    
    d.push_back(0); tren.push_back(0); pojedeno.push_back(0);
    for(long long int i=0; i<N; i++){
        cin >> a >> b;
        d.push_back(a);
        p.push_back(b);
    }
    for(long long int i=0; i<Q; i++){
        cin >> c;
        k.push_back(c);
    }
    
    int j=0;
    for(int i=0; i<N; i++){
        for(; j<Q; j++){
            if(k[j]>=d[i+1]){
                break;
            }else{
                pocetak.push_back(i);
            }
        }
    }
    for(int i=0; i<Q-j; i++){
        pocetak.push_back(N);
    }
    long long int s = 0;
    for(int i=1; i<=N; i++){
        tren.push_back(p[i-1]+max(s, tren[i-1]-(d[i]-d[i-1])));
        pojedeno.push_back(pojedeno[i-1]+min(d[i]-d[i-1], tren[i-1]));
    }
    for(int i=0; i<Q; i++){
        cout << pojedeno[pocetak[i]]+min(tren[pocetak[i]], k[i]-d[pocetak[i]]+1) << endl;
    }
    
    return 0;
}